/* soft pro dekodovani 
   dekoder infile.bin outfile.raw
*/ 

#include <stdio.h>
#include "wavout.h" 
#include "binin.h"  
#include "speech.h"      /* speech processing */
#include "config.h"      /* all config parameters */ 

int main (int argc, char **argv) {
  char *namein;
  char *nameout; 
  float frame[WIN_LEN];   /* speech frame - floats */ 
  float params[LEN_PARAMS];  /* in parameters  */
  int frmcnt=0; 
  int len;                /* length of decoded frame */

  if (argc != 3) {
    fprintf (stderr, "Usage: dekoder infile.bin outfile.raw\n");
    exit (1); 
  }
  namein = argv[1]; 
  nameout = argv[2]; 

  open_bin_file (namein); 
  open_raw_file (nameout); 

  /* process frames */ 
  while (new_frame(params)) {
    // printf ("has params\n"); fflush (stdout); 
    len = decode_frame (params,frame); 
    write_samples (frame, len); 
    frmcnt ++; 
  }
  
  close_bin_file(); 
  close_raw_file();
  fprintf (stderr, "%s -> %s %d frames\n",namein,nameout,frmcnt); 
  return (0); 
}
