/* functions for speech processing - decoding */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "speech.h"
#include "config.h"

/* main function for processing one speech frame */
/*   10 floats - LPC coeffs
   1  float  - Energy 
   1  float  - lag  
   returns the length of decoded frame */
int decode_frame (float *params, float *frame) {
  float A[LPC_COEFFS+1];      /* including the 0th one */
  float E; 
  int L;                      /* lag will be integer here  ... */
  int len;                    /* samples to do - will be WIN_LEN for the 1st 
				 frame, then WIN_SHIFT */
  float e[WIN_LEN];           /* excitation */
  float x[WIN_LEN];           /* output signal - bad energy */
                              /* output signal with good energy will be written
			         to frame */
  static int first_frame = 1;  

  ... 

  return len;
}

/* generate Pulses - has to remember the position of previous one ... */
void Pulses (int len, int L, float *out) {
  int i; 
  static int last=-1;  /* this is giving the position of the last pulse 
			  relative to THIS frame */

  /* first set everything to zero */
  for (i=0; i<len; i++) out[i] = 0.0; 

  /* if L too big, it can hapen that  we CAN NOT place any pulse ...  */
  if (last + L > len-1) { /* in this case, only shift the pulse for the NEXT 
			   frame */
    last -= len;
    return;
  }

  /* ok, can place something ... */
  for (i=last + L; i<len; i+=L) 
    if (i >= 0) /* this checks we are not in history ! */
      out[i] = PULSE; 
  
  /* at the end, prepare the position of the last pulse for NEXT frame */
  last = i-L-len; 
  return;
}

/* generate Noise - no playing with Gaussian noise, just uniform ... */
void Noise (int len, float *out) {
  int i; 
  for (i=0; i<len; i++) 
    out[i] = drand48() - 0.5; 

  return; 
}

/* FilterIIR **/

void FilterIIR (float *e, float *A, int len, float *x)
{
  static float Amem[LPC_COEFFS+2]; /* last element is dummy - just the shift */
  static int first_pass=1;
  int i,n; 
  float sum; 
   
  if (first_pass) { /* must set the memory to zeros */
    for (i=0; i<=LPC_COEFFS; i++) 
      Amem[i] = 0.0; 
    first_pass = 0;
  }

  /* ok, go filtering */
  for (n=0; n<len; n++) {
    sum = e[n]; 
    /* the output part */
    for (i=LPC_COEFFS; i>=1; i--) {
      sum -= Amem[i] * A[i];    /* sign - at coeffs ! */
      Amem[i+1] = Amem[i]; 
    }
    Amem[1] = sum; 
    x[n] = sum; 
  }
  return; 
}

